PRO fighiaq,date,xiq,yiq,xia,yia,xwq,ywq,xwa,ywa

;Plots histograms of intensities of quiet and
;active regions in IR and WL movies.
;date - 23 or 25 

on_error,1
if (date ne 23) and (date ne 25) then  $
   message,'Sorry, I do not know how to handle this dataset'
dat=strtrim(date,2)

if date eq 23 then begin
	si=[3,408,320,118]	;orig. size
	qx1=246		; subfield of quiet region
	qx2=379
	qy1=182
	qy2=291
endif else begin
	si=[3,388,300,150]	;orig. size
	qx1=304		; subfield of quiet region
	qx2=363
	qy1=135
	qy2=274
endelse

tp=0.90		;WL threshold intensity for pores
;ta=0.028	;threshold for active region in smoothed dif.images (v1)
ta=(-0.034)	;   -"- (v2)
mini=0.9	;limits for histograms
maxi=1.1

; 1st part -----------------------------------------------------

moi=intarr(si(1),si(2),si(3))	;INPUT
mow=intarr(si(1),si(2),si(3))
openr,1,'../irdata/isi'+dat+'a.bin'
readu,1,moi
close,1
openr,1,'../wldata/wsi'+dat+'a.bin'
readu,1,mow
close,1

;remove apodized edges and convert to float

moi=float(moi(10:si(1)-11,10:si(2)-11,7:si(3)-8))
mow=float(mow(10:si(1)-11,10:si(2)-11,7:si(3)-8))
n=si(3)-8-7

;normalization to mean int. of quiet regions

for i=0,n do moi(0,0,i)=moi(*,*,i)/mean(moi(qx1:qx2,qy1:qy2,i))
for i=0,n do mow(0,0,i)=mow(*,*,i)/mean(mow(qx1:qx2,qy1:qy2,i))
mqi=moi(qx1:qx2,qy1:qy2,*)
mqw=mow(qx1:qx2,qy1:qy2,*)

  ;excluding mask for pores
  ;bmp=mow gt tp	;(v1)

;differential images
  ;dwv=mow-2*moi+1.	;(v1)

cwl=stdev(mqw)		;(v2)
cir=stdev(mqi)
fact=cwl/cir
print,'WL/IR: factor =',fact
dwv=(moi-1.)*fact-(mow-1.)
dwv=smooth(dwv,5)	;smoothing by 5x5x5 pix boxcar

  ;mask for active regions, excluding pores
  ;bma=(dwv gt ta)*bmp	;(v1)

;active regions

moi=moi(where((mow gt tp) and (dwv lt ta)))
mow=mow(where((mow gt tp) and (dwv lt ta)))

  ;moi=moi*bma		;(v1)
  ;mow=mow*bma		;(v1)

;histograms

histy,mqi,xiq,yiq1,bin=0.0005,min=mini,max=maxi
histy,mqw,xwq,ywq1,bin=0.0005,min=mini,max=maxi
histy,moi,xia,yia1,bin=0.0005,min=mini,max=maxi
histy,mow,xwa,ywa1,bin=0.0005,min=mini,max=maxi

;statistics

w=where((mqi ge mini) and (mqi le maxi))
 meaqi1=mean(mqi(w))
 stdqi1=stdev(mqi(w))
 medqi1=median(mqi(w))
w=where((moi ge mini) and (moi le maxi))
 meaai1=mean(moi(w))
 stdai1=stdev(moi(w))
 medai1=median(moi(w))
w=where((mqw ge mini) and (mqw le maxi))
 meaqw1=mean(mqw(w))
 stdqw1=stdev(mqw(w))
 medqw1=median(mqw(w))
w=where((mow ge mini) and (mow le maxi))
 meaaw1=mean(mow(w))
 stdaw1=stdev(mow(w))
 medaw1=median(mow(w))

; 2nd part -----------------------------------------------------

moi=intarr(si(1),si(2),si(3))	;INPUT
mow=intarr(si(1),si(2),si(3))
openr,1,'../irdata/isi'+dat+'b.bin'
readu,1,moi
close,1
openr,1,'../wldata/wsi'+dat+'b.bin'
readu,1,mow
close,1

;remove apodized edges and convert to float

moi=float(moi(10:si(1)-11,10:si(2)-11,7:si(3)-8))
mow=float(mow(10:si(1)-11,10:si(2)-11,7:si(3)-8))
n=si(3)-8-7

;normalization to mean int. of quiet regions

for i=0,n do moi(0,0,i)=moi(*,*,i)/mean(moi(qx1:qx2,qy1:qy2,i))
for i=0,n do mow(0,0,i)=mow(*,*,i)/mean(mow(qx1:qx2,qy1:qy2,i))
mqi=moi(qx1:qx2,qy1:qy2,*)
mqw=mow(qx1:qx2,qy1:qy2,*)

  ;excluding mask for pores
  ;bmp=mow gt tp	;(v1)

;differential images
  ;dwv=mow-2*moi+1.	;(v1)

cwl=stdev(mqw)		;(v2)
cir=stdev(mqi)
fact=cwl/cir
print,'WL/IR: factor =',fact
dwv=(moi-1.)*fact-(mow-1.)
dwv=smooth(dwv,5)	;smoothing by 5x5x5 pix boxcar

  ;mask for active regions, excluding pores
  ;bma=(dwv gt ta)*bmp	;(v1)

;active regions

moi=moi(where((mow gt tp) and (dwv lt ta)))
mow=mow(where((mow gt tp) and (dwv lt ta)))

  ;moi=moi*bma		;(v1)
  ;mow=mow*bma		;(v1)

;histograms

histy,mqi,xiq,yiq2,bin=0.0005,min=mini,max=maxi
histy,mqw,xwq,ywq2,bin=0.0005,min=mini,max=maxi
histy,moi,xia,yia2,bin=0.0005,min=mini,max=maxi
histy,mow,xwa,ywa2,bin=0.0005,min=mini,max=maxi

;statistics

w=where((mqi ge mini) and (mqi le maxi))
 meaqi2=mean(mqi(w))
 stdqi2=stdev(mqi(w))
 medqi2=median(mqi(w))
w=where((moi ge mini) and (moi le maxi))
 meaai2=mean(moi(w))
 stdai2=stdev(moi(w))
 medai2=median(moi(w))
w=where((mqw ge mini) and (mqw le maxi))
 meaqw2=mean(mqw(w))
 stdqw2=stdev(mqw(w))
 medqw2=median(mqw(w))
w=where((mow ge mini) and (mow le maxi))
 meaaw2=mean(mow(w))
 stdaw2=stdev(mow(w))
 medaw2=median(mow(w))

; Output ----------------------------------------------------

print,' STATISTICS:'
print,'    IR quiet:'
print,'      mean   =',(meaqi1+meaqi2)/2
print,'      stdev  =',(stdqi1+stdqi2)/2
print,'      median =',(medqi1+medqi2)/2
print,'    IR active:'
print,'      mean   =',(meaai1+meaai2)/2
print,'      stdev  =',(stdai1+stdai2)/2
print,'      median =',(medai1+medai2)/2
print,'    WL quiet:'
print,'      mean   =',(meaqw1+meaqw2)/2
print,'      stdev  =',(stdqw1+stdqw2)/2
print,'      median =',(medqw1+medqw2)/2
print,'    WL active:'
print,'      mean   =',(meaaw1+meaaw2)/2
print,'      stdev  =',(stdaw1+stdaw2)/2
print,'      median =',(medaw1+medaw2)/2
print,'  '

yiq=(yiq1+yiq2)/2
yia=(yia1+yia2)/2
ywq=(ywq1+ywq2)/2
ywa=(ywa1+ywa2)/2

;plotting

; set_plot,'ps'
; device,file='hiaq'+dat+'.ps',yoffset=5,ysize=20
; device,file='hiaq'+dat+'.eps',yoffset=5,xsize=12,ysize=15,encapsulated=1
!p.multi=[0,0,2,0,0]

plot,xiq,yiq,linestyle=0,thick=1,xra=[0.9,1.1],/xst,  $ ;,psym=10
	title='!4k = 1.55 l!3m',xtitle='Intensity',  $
	ytitle='Normalized frequency',charsiz=1
oplot,xia,yia,linestyle=1,thick=3          ;,psym=10

plot,xwq,ywq,linestyle=0,thick=1,xra=[0.9,1.1],/xst,  $ ;,psym=10
	title='!4k = 0.8 l!3m',xtitle='Intensity',  $
	ytitle='Normalized frequency',charsiz=1
oplot,xwa,ywa,linestyle=1,thick=3          ;,psym=10

; device,/close
!p.multi=0
; set_plot,'x'

END
