PRO wnorm,date,x1,x2,y1,y2,ncarr
;
;Normalization and rms granular contrast calculation of WL images.
;INPUT:  date = 23 or 25
;	 x1,x2,y1,y2 = boundaries of granular subfield
;	 files XXjun/wfXX.seq, where XX is the date
;OUTPUT: ncarr = 2-column array with mean and rms contrast
;	 files XXjun/wnXX.seq  -  normalized frames
;
on_error,1

if (date ne 23) and (date ne 25) then  $
   message,'Sorry, I do not know how to handle this dataset'
dat=strtrim(date,2)
nami=dat+'jun/wf'+dat+'.'
namo=dat+'jun/wn'+dat+'.'
if date eq 23 then n=320 else n=359
im=intarr(1528,1024)
ncarr=fltarr(2,n+1)

for i=0,n do begin
  openr,1,nami+strtrim(i,2)
  readu,1,im
  close,1
  std=stdev(im(x1:x2,y1:y2),mea)
  ncarr(0,i)=mea
  ncarr(1,i)=std/mea
  ima=im/mea*10000.
  ima=nint(ima)
  print,namo+strtrim(i,2)
  openw,1,namo+strtrim(i,2)
  writeu,1,ima
  close,1
endfor

END
