PRO look,mov

;Displaying a sequence of subfields (boxes) in a movie to
;a panel.
;INPUT: 3-D movie mov. OUTPUT: pretty picture on the screen.

dim=size(mov)

read,'First, Last image in the displayed sequence: ',fir,las
fir=fir>0
las=las<dim(3)-1
n=fix(las-fir)+1

window,2,xsize=dim(1),ysize=dim(2),title='Select area'
tvscl,mov(*,*,fir)

box:
   print,'select lower left and upper right corners with cursor'
   cursor,x1,y1,/device,/down
   if !err eq 4 then goto,manual	; RIGHT mouse button
   cursor,x2,y2,/device,/down
   if (x2 le x1) or (y2 le y1) then goto,box
   plots,[x1,x2,x2,x1,x1],[y1,y1,y2,y2,y1],/device
   print,'Corners: ',x1,y1,' and ',x2,y2,'  Box OK ? (y/n)'
   if get_kbrd(1) eq 'n' then goto,box
   goto,array

manual:
   read,'Type x1,y1,x2,y2 of ll and ur corners: ',x1,y1,x2,y2
   plots,[x1,x2,x2,x1,x1],[y1,y1,y2,y2,y1],/device
   print,'Corners',x1,y1,'  and',x2,y2,'.  Box OK ? (y/n)'
   if get_kbrd(1) eq 'n' then goto,box

array:
   arr=mov(x1:x2,y1:y2,fir:las)	;array to be displayed

;output window

nx=x2-x1+1		;size of the box
ny=y2-y1+1
nfx=fix(1000/nx)	;no of boxes in one row of an xsize=1000 window
xsi=nfx*nx
ysi=fix(n/nfx+1)*ny
window,2,xsize=xsi,ysize=ysi,title='Evolutionary sequence'

print,'Edge enhancement ? (y/n)'
if get_kbrd(1) eq 'y' then begin
   for i=0,n-1 do tvscl,arr(*,*,i)-0.7*smooth(arr(*,*,i),5),i
   print,'Do you like it ? (y/n)'
   if get_kbrd(1) eq 'y' then goto,fin
endif

for i=0,n-1 do tvscl,arr(*,*,i),i

fin:
END
