FUNCTION ffddprep,day,type,list
;
; Inspection and preparation of flats and darks for the pre-reduction
; of SST data, September 2003.
; INPUTS: day = 14, 16, 18, 19, 20   ...date
;	  type = 'gc', 'c6', 'ca'    ...channel
;	  list = list of seq. numbers of frames to be averaged
; RETURNS: image array. Division by 50 is made.
; CALLING: result (FLOAT array) = ffddprep(14,'gc',[48,49,50,51])
;

on_error,1

; loop over frames in LIST

cnt=0
sum=0
nn=n_elements(list)

for num=list(0),list(nn-1) do begin

; paths and filenames

pa1='/scratch1/sobotka/lap2003/images_out/'

if (day eq 14) or (day eq 16) then begin
	pa2=type+'_'+strtrim(fix(day),2)+'/'
	fil='*.'+string(num,format='(I4.4)')
endif else begin
	if (type eq 'ca') or (type eq 'cah') then begin
		type='cah'
		cam='42'
	endif else begin
		cam='16'
	endelse
	pa2='images'+cam+'-'+type+'-'+strtrim(fix(day),2)+'/'
	fil='*.'+string(num,format='(I6.6)')
endelse

name=findfile(pa1+pa2+fil)
if (size(name))(1) ne 1 then message,' file not found'
print,'Reading:  ',name

; reading image

if (day eq 14) or (day eq 16) then  restore2,name,im  $
	else  im=f1(name,he)
help,im
si=size(im)
window,0,xs=si(1)/3,ys=si(2)/3
tvscl,congrid(im,si(1)/3,si(2)/3)
window,2,xs=400
histy,im,bin=5

;summation

print,'ACCEPT? y/n'
if get_kbrd(1) eq 'n' then goto,skip
sum=sum+im
cnt=cnt+1

skip:
endfor

print,cnt,'  frames summed'
sum=float(sum/(cnt*50.))		; observed FF and DD are sums of 50 frames
wset,0
tvscl,congrid(sum,si(1)/3,si(2)/3)
wset,2
histy,sum,bin=5

RETURN,sum
END
