PRO fields,day,num,gc,c6
;
; Reads 'gc' and registered 'c6' images
;
; INPUTS: day = 16, 19, 20   ...date
;	  num = seq. number
; OUTPUTS: gc,c6 = working subfields of the original 'gc' and 'c6' images
;
on_error,1

; PATHS AND NAMES =============================================

sday=strtrim(fix(day),2)
dsday=sday		;historical by now
num=string(num,format='(I4.4)')

pa1='/home/msobotka/data/sst03/'
pagc='gc_'+dsday+'/'
pac6='c6_'+dsday+'/'
figc='gc_'+sday+'rr.'+num	; input restored gc
fic6='c6_'+sday+'mm.'+num	; input restored and registered c6

; =============================================================

; Reading
  print,'Reading ',figc,'  ',fic6
  restore2,pa1+pagc+figc,gc
  restore2,pa1+pac6+fic6,c6

; Subfields

case 1 of
  day eq 16: begin
    read,'1st part (1) or 2nd part (2)?: ',di
    if di eq 1 then begin
	gc=gc(390:645,350:625)
	c6=c6(390:645,350:625)
    endif else begin
	gc=gc(340:715,330:705)
	c6=c6(340:715,330:705)
    endelse
  end
  day eq 19: begin
    read,'1st part (1) or 2nd part (2)?: ',di
    if di eq 1 then begin
	gc=gc(142:685,308:691)
	c6=c6(142:685,308:691)
    endif else begin
	gc=gc(525:956,340:867)
	c6=c6(525:956,340:867)
    endelse
  end
  day eq 20: begin
	gc=gc(250:777,350:877)
	c6=c6(250:777,350:877)
  end
  else: message,' Wrong day.'
endcase
si=size(gc)

window,0,xs=si(1),ys=si(2)
tvscl,gc
window,2,xs=si(1),ys=si(2)
tvscl,c6

END

