PRO readsstlog,log,n,logarr
;
;Reads the logfiles of the SST Megaplus cameras (September 2003)
;
;INPUT:   log = 'logfile_name',  n = number of lines (frames)
;OUTPUT:  logarr = FLOAT array (4,n) where
;		logarr(0) ... sequential number
;		logarr(1) ... time UT hours.decimal
;		logarr(2) ... quality
;		logarr(3) ... exposure time (ms)
;
;CALLING: readsstlog,'m16gc_lg20Sep2003',150,log20gc
;
;21 Sept 2003, Michal

openr,1,log
logarr=fltarr(4,n)
str=''

for i=0,n-1 do begin

  readf,1,str
  logarr(0,i)= float(strmid(str,0,11))		;seq. number
  tim=strmid(str,13,12)			;time string
   ti=str_sep(tim,':')			;time, separator ":"  
   hour=float(ti(0))
   minu=float(ti(1))
   seco=float(ti(2))
  logarr(1,i)= (hour*3600+minu*60+seco)/3600.	;time in hours
  logarr(2,i)= float(strmid(str,46,5))		;quality
  logarr(3,i)= float(strmid(str,39,4))		;exposure
  
endfor

close,1
END
