pro vipd2,vx1,vy1,thr,lev,im
;
; modification of vpd
; CONTOURS OF V=sqrt(VX^2+VY^2) overplotted over IM
; white background, dark coordinates
; thr  ... threshold to cut out too high values in vx1,vy1
; lev  ... array of countour levels
;

; Scaling to velocity in km/s - present units in pix/lag,
; i.e. if 1 pix = 90.6 km (0.125") and lag = 1 frame = 44.5 s,
; then 1 pix / 1 lag  =  2.04 km/s
scale=2.04

if n_elements(lev) lt 2 then begin
   print,'usage: VIPD2,VX,VY,threshold,[lev1,lev2,lev3,...],ima'
   goto,fin
endif

vx=vx1>(-thr)
vx=vx<thr
vy=vy1>(-thr)
vy=vy<thr
;
px=!x.window*!d.x_vsize
py=!y.window*!d.y_vsize
sx=px(1)-px(0)+1
sy=py(1)-py(0)+1
print,'new image size:',sx,sy
erase
          
tv,bytarr(!d.x_vsize,!d.y_vsize)+255      ; differs from vpd

;set_plot,'ps'
;device,filename='d;\data\palma\map.ps',/color
;loadct,3
tv,congrid(bytscl(im),sx,sy,/cubic),px(0),py(0)
;tv,congrid(bytscl(im),sx,sy,/cubic),0,0,xsize=12.7,ysize=12.7,/centimeters
;
mag=sqrt(vx^2+vy^2)*scale
s=size(mag)
lmax=max(mag)
lmin=min(mag)
print,'min, max and mean of velocity modulus:',lmin,lmax,mean(mag)
x0=0
x1=0
y0=0
y1=0
;!p.position=[0,0,0.7155,1]
;plot,[x0,x1],[y0,y1],/nodata,xrange=[0,s(1)],yrange=[0,s(2)],title='vel',$
;    xstyle=1,ystyle=1,/noerase,/normal,xthick=5,ythick=5,charthick=5

plot,[x0,x1],/nodata,xrange=[0,s(1)],yrange=[0,s(2)],xstyle=1,ystyle=1,$
/noerase,color=0,charsize=1 ; no color and charsize specification in vpd

clab=intarr(n_elements(lev))+1	; label all contours

contour,mag,xstyle=5,ystyle=5,/noerase,c_labels=clab, $
       levels=lev,color=0,/normal,c_thick=1,/follow

;device,/close
;set_plot,'x'
fin:
end
